import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Label;
import java.awt.Panel;
import java.awt.Point;
import java.awt.TextField;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import luchr.awt.FramedPanel;

class EinsatzDialog extends Dialog
{
	static final int OK = 1,	CANCEL = 2;

	public int endAction;
	public int betrag;

	private TextField betragField;
	private int min,max;

	public EinsatzDialog (Frame parent, String title, int min, int max)
	{
		super(parent,title,true);
		this.min = min;
		this.max = max;

		addWindowListener(new WindowAdapter () {
			public void windowClosing (WindowEvent e)
			{
				endDialog(CANCEL);
			}
		});

		setLayout(new GridBagLayout());

		GridBagConstraints mgc = new GridBagConstraints();

		// ---- Panel with TextField and Label
		{
			FramedPanel p = new FramedPanel(FramedPanel.DRAW_UP,new BorderLayout(0,0));
			// ---- TextField
			{
				betragField = new TextField(15);
				betragField.addKeyListener(new KeyAdapter () {
					public void keyReleased (KeyEvent e)
					{
						if (e.getKeyCode()==e.VK_ENTER) endDialog(OK);
					}
				});
				p.add(betragField,"South");
			}
			// ---- Label
			{
				p.add(new Label("Betrag",Label.CENTER),"North");
			}
			mgc.gridx=0;mgc.gridy=0;
			mgc.gridwidth=1;mgc.gridheight=1;
			mgc.fill=mgc.NONE;
			mgc.ipadx=0;mgc.ipady=0;
			mgc.insets=new Insets(5,5,5,5);
			mgc.anchor=mgc.CENTER;
			mgc.weightx=0;mgc.weighty=0;
			add(p,mgc);
		}

		// ---- Panel with Buttons
		{
			Panel p = new Panel(new BorderLayout(5,5));
			// ---- Button OK
			{
				Button b = new Button("Ok");
				b.addActionListener(new ActionListener () {
					public void actionPerformed (ActionEvent e)
					{
						endDialog(OK);
					}
				});
				p.add(b,"North");
			}
			// ---- Button Cancel
			{
				Button b = new Button("Cancel");
				b.addActionListener(new ActionListener () {
					public void actionPerformed (ActionEvent e)
					{
						endDialog(CANCEL);
					}
				});
				p.add(b,"South");
			}
			mgc.gridx=1;mgc.gridy=0;
			mgc.gridwidth=1;mgc.gridheight=1;
			mgc.fill=mgc.NONE;
			mgc.ipadx=0;mgc.ipady=0;
			mgc.insets=new Insets(5,5,5,5);
			mgc.anchor=mgc.CENTER;
			mgc.weightx=0;mgc.weighty=0;
			add(p,mgc);
		}

		pack();
		Dimension dScreen = getToolkit().getScreenSize();
		Dimension dOwn = getSize();
		setLocation(new Point(
			(dScreen.width-dOwn.width)/2,(dScreen.height-dOwn.height)/2));
		show();
	}
	public void endDialog (int action)
	{
		if (action==OK)
			try
			{
				betrag = Integer.valueOf(betragField.getText()).intValue();
				if (betrag<min || betrag>max) return;
			} catch (NumberFormatException e)
				{return;}
		endAction=action;
		dispose();
	}
}
