import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Insets;
import java.awt.Point;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import luchr.awt.MultiLineLabel;

class ErrorDialog extends Dialog
{
	public ErrorDialog (Frame parent, String title, String message)
	{
		this(parent,title,message,null);
	}
	public ErrorDialog (Frame parent, String title, String message, Font font)
	{
		super(parent,title,true);
		setLayout(new BorderLayout(2,2));

		MultiLineLabel ml = new MultiLineLabel(message,MultiLineLabel.CENTER);
		if (font!=null) ml.setFont(font);
		add(ml,"North");

		Button b = new Button("Ok");
		b.addActionListener(new ActionListener () {
			public void actionPerformed (ActionEvent e)
				{dispose();}
		});
		add(b,"South");

		addWindowListener(new WindowAdapter () {
			public void windowClosing (WindowEvent e)
				{dispose();}
		});

		pack();
		Dimension dScreen = getToolkit().getScreenSize();
		Dimension dOwn = getSize();
		setLocation(new Point(
			(dScreen.width-dOwn.width)/2,(dScreen.height-dOwn.height)/2));
		show();
	}
	public Insets getInsets ()
	{
		Insets i = super.getInsets();
		i.bottom+=5;i.top+=5;
		i.left+=5;i.right+=5;
		return i;
	}
}
