import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Panel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import luchr.awt.FramedPanel;

import luchr.io.IniFile;

class MainWindow extends SubWindow
{
	Checkbox[] checkbox	= new Checkbox[
		ProgManager.subWindowManager.getSubWindowCount()];
	SubWindowSupervisor subsup;
	public MainWindow (IniFile.Section ownSection,
		String title, SubWindowSupervisor supervisor)
	{
		super(ownSection,title,true,null);

		subsup=supervisor;

		addWindowListener(new WindowAdapter () {
			public void windowClosing (WindowEvent e)
			{
				ProgManager.endProgram();
			}
		});

		setLayout(new GridBagLayout());
		GridBagConstraints mgc = new GridBagConstraints();

		// ---- Panel with Buttons
		{
			Panel p = new Panel(new GridLayout(2,1,0,5));
			// ---- Button: Neues Spiel
			{
				Button b = new Button("Neues Spiel");
				b.addActionListener(new ActionListener () {
					public void actionPerformed (ActionEvent e)
					{
						ProgManager.newGame();
					}
				});
				p.add(b);
			}
			// ---- Button: Programm beenden
			{
				Button b = new Button("Programm beenden");
				b.addActionListener(new ActionListener () {
					public void actionPerformed (ActionEvent e)
					{
						ProgManager.endProgram();
					}
				});
				p.add(b);
			}
			mgc.gridx=1;mgc.gridy=0;
			mgc.gridwidth=1;mgc.gridheight=1;
			mgc.fill=mgc.NONE;
			mgc.ipadx=0;mgc.ipady=0;
			mgc.insets=new Insets(5,5,5,5);
			mgc.anchor=mgc.CENTER;
			mgc.weightx=0;mgc.weighty=0;
			add(p,mgc);
		}
		// ---- FramedPanel witth CheckBoxes
		{
			int subnumber = ProgManager.subWindowManager.getSubWindowCount();
			FramedPanel p = new FramedPanel(FramedPanel.DRAW_UP,
				new GridLayout(subnumber/2,2,0,5));
			// ---- Checkboxes
			{
				for (int i=0; i<subnumber; i++)
				{
					checkbox[i] = new Checkbox(
						ProgManager.subWindowManager.getSubWindowTitle(i));
					checkbox[i].addItemListener(new ItemListener () {
						public void itemStateChanged (ItemEvent e)
						{
							subsup.subWindowClosing((String)(e.getItem()));
						}
					});
					p.add(checkbox[i]);
				}
			}
			mgc.gridx=0;mgc.gridy=0;
			mgc.gridwidth=1;mgc.gridheight=1;
			mgc.fill=mgc.NONE;
			mgc.ipadx=0;mgc.ipady=0;
			mgc.insets=new Insets(5,5,5,5);
			mgc.anchor=mgc.CENTER;
			mgc.weightx=0;mgc.weighty=0;
			add(p,mgc);
		}

		setupWindow();
	}
}
