import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Font;
import java.awt.Panel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.util.Random;

import luchr.awt.FramedPanel;
import luchr.awt.MultiLineLabel;

import luchr.io.IniFile;

class NumberWindow extends SubWindow
{
	MultiLineLabel numberLabel;
	Button				 startButton;
	int						erg;
	Random				 zufall;

	public NumberWindow (IniFile.Section ownSection,String title,
		SubWindowSupervisor supervisor)
	{
		super(ownSection,title,false,supervisor);

		zufall = new Random();

		FramedPanel p = new FramedPanel(new BorderLayout());
		numberLabel = new MultiLineLabel("88",MultiLineLabel.CENTER,
			new Font("Serif",Font.BOLD,80),10,10);
		p.add(numberLabel,"North");
		add(p,"North");

		startButton = new Button("Start");
		startButton.addActionListener(new ActionListener () {
			public void actionPerformed (ActionEvent e)
			{
				rollNumbers();
			}
		});
		add(startButton,"South");

		setResizable(false);
		setupWindow();
	}

	public void setupWindow ()
	{
		super.setupWindow();
		setNumber(0);
	}

	public void setNumber (int no)
	{
		if (Numbers.isNumberInArray(no,Numbers.REDNUMBERS))
			setForeground(Color.red); else
		if (Numbers.isNumberInArray(no,Numbers.BLACKNUMBERS))
			setForeground(Color.black); else
			setForeground(Color.green);
		numberLabel.setLabel(String.valueOf(no));
		erg=no;
		numberLabel.paint(numberLabel.getGraphics());
	}

	public void rollNumbers ()
	{
		int ende = (int)(zufall.nextFloat()*100+10);
		for (int i=0; i<ende; i++) setNumber((int)(zufall.nextFloat()*36));
	}
}
