class NumbersChosen
{
	static final int
		MT_NO			 =	0,		MT_ONE			=	1,		MT_TWOH		 =	2,
		MT_TWOV		 =	3,		MT_FOUR		 =	4,		MT_THREER	 =	5,
		MT_THREEL	 =	6,		MT_SIXR		 =	7,		MT_SIXL		 =	8,
		MT_TWELVER	=	9,		MT_TWELVEDL = 10,		MT_TWELVEDR = 11,
		MT_FOURZR	 = 12,		MT_FOURZL	 = 13,		MT_EIGHTEEN = 14;

	static final String[] MARKTYPEDESCRIPT =
		{null,"1 Zahl","2 Zahlen (h)","2 Zahlen (v)",
		 "4 Zahlen","3er Reihe","3er Reihe","6er Reihe",
		 "6er Reihe","12er Reihe","Dutzend","Dutzend",
		 "4 Zahlen","4 Zahlen"};

	int[]	numbers;
	int		markType;
	int		position;
	int		einsatz;
	int		erhalten=0;

	public NumbersChosen (int markType, int position, int[] numbers, int einsatz)
	{
		super();
		this.markType = markType;
		this.position = position;
		this.numbers = numbers;
		this.einsatz = einsatz;
	}
	public NumbersChosen (int markType, int position, int[] numbers)
	{
		this(markType,position,numbers,0);
	}
	public NumbersChosen (int markType, int[] numbers)
	{
		this(markType,0,numbers);
	}

	public void addEinsatz (int zusatz)
	{
		einsatz += zusatz;
	}

	public boolean equalsLocation (NumbersChosen obj)
	{
		boolean erg = true;
		erg = ((numbers==null) && (obj.numbers==null)) ||
					((numbers!=null) && (obj.numbers!=null));
		if (!erg) return false;

		if (numbers!=null)
		{
			erg = numbers.length==obj.numbers.length;
			if (!erg) return false;

			for (int i=0; i<numbers.length; i++)
				erg=numbers[i]==obj.numbers[i];
			if (!erg) return false;
		}

		return (markType==obj.markType) && (position==obj.position);
	}
	public boolean equals (NumbersChosen obj)
	{
		return equalsLocation(obj) && einsatz==obj.einsatz;
	}

	public String getNumbersDescription ()
	{
		if ((numbers==null) || (numbers.length==0)) return null;
		String erg="";
		if (numbers.length<5)
			for (int i=0; i<numbers.length; i++)
			{
				erg=erg+String.valueOf(numbers[i]);
				if (i!=numbers.length-1) erg=erg+",";
			}
		else erg=numbers[0]+","+numbers[1]+",...,"+numbers[numbers.length-1];
		return erg;
	}
	public String getMarkTypeDescription ()
	{
		String descript=null;
		if (markType==MT_EIGHTEEN)
			switch (position)
			{
				case	0: descript="2. Haelfte";break;
				case 10: descript="1. Haelfte";break;
				case	1: descript="Gerade";break;
				case 11: descript="Ungerade";break;
				case	2: descript="Schwarz";break;
				case 12: descript="Rot";break;
			} else descript=MARKTYPEDESCRIPT[markType];
		return descript;
	}
	public String toString ()
	{
		return "NumbersChosen: "+getMarkTypeDescription()+": "+
			getNumbersDescription();
	}
}
