import java.awt.Dimension;
import java.awt.Font;
import java.awt.List;

import luchr.io.IniFile;

class ProbabilityWindow extends SubWindow
{
	private int		count;
	private int[]	number=new int[37];

	List probabilityList;
	Font probabilityFont;

	static final String
		ENT_FONTNAME = "FontName",	ENT_FONTSTYLE = "FontStyle",
		ENT_FONTSIZE = "FontSize",
		ENT_WIDTH = "Width",	 ENT_HEIGHT = "Height",
		HEAD			= " Zahl	Haeufigk.",
		SEPERATOR = "----------------";

	public ProbabilityWindow (IniFile.Section ownSection, String title,
		SubWindowSupervisor supervisor)
	{
		super(ownSection,title,false,supervisor);


		probabilityFont = new Font(
			ownSection.getEntryByKey(ENT_FONTNAME).getStringValue(),
			ownSection.getEntryByKey(ENT_FONTSTYLE).getIntValue(),
			ownSection.getEntryByKey(ENT_FONTSIZE).getIntValue());

		// ---- List
		{
			probabilityList = new List(37);
			probabilityList.setFont(probabilityFont);
			add(probabilityList);
		}

		setupWindow();
		setSize(
			ownSection.getEntryByKey(ENT_WIDTH).getIntValue(),
			ownSection.getEntryByKey(ENT_HEIGHT).getIntValue());

		reset();
	}

	public void initIniSection ()
	{
		super.initIniSection();
		IniFile.EntryChecker.checkStringEntry(ownSection,ENT_FONTNAME,"MonoSpaced");
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_FONTSTYLE,Font.PLAIN);
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_FONTSIZE,10);
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_WIDTH,112);
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_HEIGHT,500);
	}
	public void doneIniSection ()
	{
		Dimension size=getSize();
		ownSection.getEntryByKey(ENT_WIDTH).setValue(size.width);
		ownSection.getEntryByKey(ENT_HEIGHT).setValue(size.height);
		super.doneIniSection();
	}
	public double getNumberProbability (int index)
	{
		return 100.0d*number[index]/count;
	}
	public void updateProbability (int index)
	{
		probabilityList.setVisible(false);
		probabilityList.removeAll();
		probabilityList.add(HEAD);probabilityList.add(SEPERATOR);
		count+=1;number[index] += 1;
		for (int i=0; i<37; i++)
		{
			String number=String.valueOf(i);
			while (number.length()<4) number=" "+number;

			String probability=String.valueOf(getNumberProbability(i));
			while (probability.length()<7) probability=" "+probability;
			probabilityList.add(number+"	 "+probability);
		}
		probabilityList.setVisible(true);
	}
	public void reset ()
	{
		count=0;
		for (int i=0; i<37; i++) number[i]=0;
		probabilityList.removeAll();
	}
}
