import java.awt.Dimension;
import java.awt.Font;
import java.awt.List;

import luchr.lang.Collection;

import luchr.io.IniFile;

class ProfitWindow extends SubWindow
{
	static final String
		ENT_FONTNAME = "FontName",	ENT_FONTSTYLE = "FontStyle",
		ENT_FONTSIZE = "FontSize",
		ENT_WIDTH = "Width",	 ENT_HEIGHT = "Height",
		HEAD			= " Zahl		Gewinn",
		SEPERATOR = "----------------";

	List profitList;
	Font profitFont;

	public ProfitWindow (IniFile.Section ownSection, String title,
		SubWindowSupervisor supervisor)
	{
		super(ownSection,title,false,supervisor);

		profitFont = new Font(
			ownSection.getEntryByKey(ENT_FONTNAME).getStringValue(),
			ownSection.getEntryByKey(ENT_FONTSTYLE).getIntValue(),
			ownSection.getEntryByKey(ENT_FONTSIZE).getIntValue());

		// ---- List
		{
			profitList = new List (37);
			profitList.setFont(profitFont);
			add(profitList);
		}

		setupWindow();
		setSize(
			ownSection.getEntryByKey(ENT_WIDTH).getIntValue(),
			ownSection.getEntryByKey(ENT_HEIGHT).getIntValue());
	}

	public void initIniSection ()
	{
		super.initIniSection();
		IniFile.EntryChecker.checkStringEntry(ownSection,ENT_FONTNAME,"MonoSpaced");
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_FONTSTYLE,Font.PLAIN);
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_FONTSIZE,10);
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_WIDTH,112);
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_HEIGHT,500);
	}
	public void doneIniSection ()
	{
		Dimension size=getSize();
		ownSection.getEntryByKey(ENT_WIDTH).setValue(size.width);
		ownSection.getEntryByKey(ENT_HEIGHT).setValue(size.height);
		super.doneIniSection();
	}

	public void updateProfits (EinsatzCollection coll)
	{
		profitList.setVisible(false);
		profitList.removeAll();
		if (coll.getCount()!=0)
		{
			profitList.add(HEAD);profitList.add(SEPERATOR);
			for (int i=0; i<37; i++)
			{
				String number=String.valueOf(i);
				while (number.length()<4) number=" "+number;

				String profit=String.valueOf(coll.getProfit(i));
				while (profit.length()<7) profit=" "+profit;
				profitList.add(number+"	 "+profit);
			}
		}
		profitList.setVisible(true);
	}
}
