import java.awt.Dimension;
import java.awt.Font;
import java.awt.List;

import java.util.Enumeration;

import luchr.io.IniFile;

import luchr.lang.Collection;

class ProtocolWindow extends SubWindow
{
	static final String
		ENT_FONTNAME = "FontName",	ENT_FONTSTYLE = "FontStyle",
		ENT_FONTSIZE = "FontSize",
		ENT_WIDTH		= "Width",		 ENT_HEIGHT		= "Height";

	static final String 
			HEAD			= "																 gesetzt",
			PROFIT		= "	erhalten",
			SEPERATOR = "-----------------------------------------------------";

	List	protocolList;
	Font	protocolFont;
	public ProtocolWindow (IniFile.Section ownSection,String title,
		SubWindowSupervisor supervisor)
	{
		super(ownSection,title,false,supervisor);

		protocolFont = new Font(
			ownSection.getEntryByKey(ENT_FONTNAME).getStringValue(),
			ownSection.getEntryByKey(ENT_FONTSTYLE).getIntValue(),
			ownSection.getEntryByKey(ENT_FONTSIZE).getIntValue());

		// ---- List
		{
			protocolList = new List(20);
			protocolList.setFont(protocolFont);
			add(protocolList);
		}

		setupWindow();
		setSize(
			ownSection.getEntryByKey(ENT_WIDTH).getIntValue(),
			ownSection.getEntryByKey(ENT_HEIGHT).getIntValue());
	}

	public void initIniSection ()
	{
		super.initIniSection();
		IniFile.EntryChecker.checkStringEntry(ownSection,ENT_FONTNAME,"MonoSpaced");
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_FONTSTYLE,Font.PLAIN);
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_FONTSIZE,12);
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_WIDTH,300);
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_HEIGHT,400);
	}

	public void doneIniSection ()
	{
		Dimension size=getSize();
		ownSection.getEntryByKey(ENT_WIDTH).setValue(size.width);
		ownSection.getEntryByKey(ENT_HEIGHT).setValue(size.height);
		super.doneIniSection();
	}

	public void updateProtocol (EinsatzCollection coll,
		final boolean showProfit)
	{
		protocolList.setVisible(false);
		protocolList.removeAll();
		if (coll.getCount()!=0)
		{
			String line;
			if (showProfit) line=HEAD+PROFIT; else line=HEAD;
			protocolList.add(line);
			protocolList.add(SEPERATOR);
			coll.forEach(new Collection.Iteration () {
				public void doAction (Object item)
				{
					NumbersChosen nc = (NumbersChosen)(item);
	
					String descript,numbers,einsatz,erhalten=null,showLine;
	
					descript=enlargeString(nc.getMarkTypeDescription(),12);
					numbers=enlargeString(nc.getNumbersDescription(),18);
					einsatz=enlargeString(String.valueOf(nc.einsatz),7);
					if (showProfit)
						erhalten=enlargeString(String.valueOf(nc.erhalten),7);

					showLine = descript+numbers+"	 "+einsatz;
					if (showProfit) showLine=showLine+"	 "+erhalten;
		 
					protocolList.add(showLine);
				}
				public String enlargeString(String st,int size)
				{
					while (st.length()<size) st=" "+st;
					return st;
				}
			});

			if (showProfit)
			{
				protocolList.add(SEPERATOR);
				protocolList.add("Gewinn: "+coll.getProfit());
			}
		}
		protocolList.setVisible(true);
	}
}
