import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Toolkit;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import luchr.io.IniFile;

class SubWindow extends Frame
{
	static final String
		ENT_X = "x",	 ENT_Y = "y",	 ENT_VISIBLE="Visible";

	IniFile.Section ownSection;

	private boolean permanent;

	public SubWindow (IniFile.Section ownSection,
		String title, boolean permanent,final SubWindowSupervisor supervisor)
	{
		super(title);
		this.permanent = permanent;
		if (!permanent)
		{
			addWindowListener(new WindowAdapter () {
				public void windowClosing (WindowEvent e)
				{
					supervisor.subWindowClosing(getTitle());
				}
			});
		}
		this.ownSection = ownSection;
		initIniSection();
		int x = ownSection.getEntryByKey(ENT_X).getIntValue();
		int y = ownSection.getEntryByKey(ENT_Y).getIntValue();
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		if (x>screenSize.width || y>screenSize.height) {x=0; y=0;}
		setLocation(x,y);
	}
	public void setupWindow ()
	{
		pack();
		if (permanent) setVisible(true);else
			setVisible(ownSection.getEntryByKey(ENT_VISIBLE).getIntValue()==1);

	}
	public void done ()
	{
		doneIniSection();
		if (!permanent) dispose();
	}

	public void initIniSection ()
	{
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_X,0);
		IniFile.EntryChecker.checkIntEntry(ownSection,ENT_Y,0);
		if (!permanent)
			IniFile.EntryChecker.checkIntEntry(ownSection,ENT_VISIBLE,1);
	}
	public void doneIniSection ()
	{
		Point p = getLocation ();
		IniFile.Entry e;
		e=ownSection.getEntryByKey(ENT_X);e.setValue(p.x);
		e=ownSection.getEntryByKey(ENT_Y);e.setValue(p.y);
		if (!permanent)
		{
			e=ownSection.getEntryByKey(ENT_VISIBLE);
				e.setValue(isVisible()?1:0);
		}
	}

	public final void update (Graphics g) {}
	public final void paint (Graphics g) {}
}
