package luchr.awt;

import java.awt.Button;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Point;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import luchr.awt.FramedPanel;

public class ChooseDialog extends Dialog
{
	public static final int ID_NOTDEFINED = -1, ID_CANCEL = -2;
	public CheckboxGroup checkboxGroup;
	public Checkbox[]	checkbox;
	public FramedPanel choosePanel,buttonPanel;

	public int answer=ID_NOTDEFINED;

	public ChooseDialog (Frame parent, String title, String[] labelText,
		int defaultCB)
	{
		super(parent,title,true);

		addWindowListener(new WindowAdapter () {
			public void windowClosing (WindowEvent e)
				{endDialog(ID_CANCEL);}
		});

		setLayout(new GridBagLayout());
		GridBagConstraints mco = new GridBagConstraints();

		// ---- choosePanel
		{
			choosePanel=new FramedPanel(FramedPanel.DRAW_UP,
				new GridBagLayout());
			GridBagConstraints sco = new GridBagConstraints();

			checkboxGroup = new CheckboxGroup();
			checkbox = new Checkbox[labelText.length];
			for (int i=0; i<labelText.length; i++)
			{
				checkbox[i] = new Checkbox(labelText[i],checkboxGroup,i==defaultCB);
				sco.gridx=0;sco.gridy=i;
				sco.gridwidth=1;sco.gridheight=1;
				sco.fill=sco.HORIZONTAL;
				sco.insets=new Insets(0,0,0,0);
				sco.anchor=mco.CENTER;
				sco.weightx=1;sco.weighty=0;
				choosePanel.add(checkbox[i],sco);
			}
			mco.gridx=0;mco.gridy=0;
			mco.gridwidth=1;mco.gridheight=1;
			mco.fill=mco.HORIZONTAL;
			mco.insets=new Insets(0,0,0,0);
			mco.anchor=mco.CENTER;
			mco.weightx=1;mco.weighty=0;
			add(choosePanel,mco);
		}
		// ---- buttonPanel
		{
			buttonPanel=new FramedPanel(FramedPanel.DRAW_NOTHING,
				new GridLayout(1,2,35,0));
			// ---- Button Ok
			{
				Button b = new Button("Ok");
				b.addActionListener(new ActionListener () {
					public void actionPerformed (ActionEvent e)
						{endDialog(getSelectedCheckboxNumber());}
				});
				buttonPanel.add(b);
			}
			// ---- Button Cancel
			{
				Button b = new Button("Cancel");
				b.addActionListener(new ActionListener () {
					public void actionPerformed (ActionEvent e)
						{endDialog(ID_CANCEL);}
				});
				buttonPanel.add(b);
			}
			mco.gridx=0;mco.gridy=1;
			mco.gridwidth=1;mco.gridheight=1;
			mco.fill=mco.HORIZONTAL;
			mco.insets=new Insets(0,0,0,0);
			mco.anchor=mco.CENTER;
			mco.weightx=1;mco.weighty=0;
			add(buttonPanel,mco);
		}
	}

	public int getSelectedCheckboxNumber ()
	{
		Checkbox CB = checkboxGroup.getSelectedCheckbox();
		if (CB==null) return ID_NOTDEFINED;
		for (int i=0; i<checkbox.length; i++)
			if (CB==checkbox[i]) return i;
		return ID_NOTDEFINED;
	}

	protected void endDialog (int reason)
	{
		answer=reason;
		dispose();
	}

	public int execute ()
	{
		setResizable(false);
		pack();
		Dimension dScreen = getToolkit().getScreenSize();
		Dimension dOwn = getSize();
		setLocation(new Point(
			(dScreen.width-dOwn.width)/2,(dScreen.height-dOwn.height)/2));
		show();
		return answer;
	}

}
