package luchr.awt;

import java.io.ObjectInputStream;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Panel;
import java.awt.LayoutManager;

public class FramedPanel extends Panel
{
	//
	private transient Dimension	backbufsize;
	private transient Image			backbufim;
	private transient Graphics	 backbufgra = null;

	protected int drawType;
	public static final int
		DRAW_NOTHING = 0, DRAW_DOWN = 1, DRAW_UP = 2;

	public FramedPanel () {super();}
	public FramedPanel (LayoutManager l) {super(l);}
	public FramedPanel (int drawType)
	{
		super();
		setDrawType(drawType);
	}
	public FramedPanel (int drawType, LayoutManager l)
	{
		super(l);
		setDrawType(drawType);
	}

	private void readObject (ObjectInputStream in) throws
		java.io.IOException, ClassNotFoundException
	{
		in.defaultReadObject();
		backbufgra=null;
	}

	public void setDrawType (int drawType)
	{
		this.drawType = drawType;
		repaint();
	}
	public int getDrawType () {return drawType;}
	public Insets getInsets ()
	{
		return new Insets(6,6,6,5);
	}

	/*
	public void setBounds (int x, int y, int width, int height)
	{
		super.setBounds(x,y,width,height);
		repaint();
	}
	*/

	// since Jdk 1.2beta2
	public Color getBackground()
	{
		return Color.lightGray;
	}

	public void update (Graphics g)
	{
		paint(g);
	}
	public void paint (Graphics g)
	{
		Dimension size = getSize();
		if (backbufgra==null || !size.equals(backbufsize))
		{
			backbufsize = size;
			backbufim = createImage(size.width,size.height);
			backbufgra = backbufim.getGraphics();
		}
		backbufgra.setColor(getBackground());

		backbufgra.fillRect(0,0,size.width,size.height);
		if (drawType!=DRAW_NOTHING)
		{
			backbufgra.draw3DRect(0,0,size.width-1,size.height-1,drawType==DRAW_UP);
			backbufgra.draw3DRect(3,3,size.width-7,size.height-7,drawType==DRAW_DOWN);
		}
		super.paint(backbufgra);
		g.drawImage(backbufim,0,0,this);
	}

}


