package luchr.awt;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.Point;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import luchr.awt.FramedPanel;
import luchr.awt.MultiLineLabel;


public class QuestionDialog extends Dialog
{
	public FramedPanel		questionPanel;
	public MultiLineLabel questionLabel;

	public FramedPanel		buttonPanel;
	public Button[]			 button			 = new Button[3];

	public static final int
		STILLOPEN = -1,
		BUTTON0 = 0, BUTTON1 = 1, BUTTON2 = 2, CLOSE = 3;

	public int						answer=STILLOPEN;

	protected static String[] standardButtonText = new String[3];

	static
	{
		setStandardButtonText("Yes","No","Cancel");
	}

	public QuestionDialog (Frame parent, String title, boolean modal,
		String question, String answer0, String answer1, String answer2)
	{
		super(parent,title,modal);

		addWindowListener(new WindowAdapter () {
			public void windowClosing (WindowEvent e)
				{endDialog(CLOSE);}
		});

		setLayout(new BorderLayout(10,1));

		// ---- questionPanel
		{
			questionPanel = new FramedPanel(FramedPanel.DRAW_UP,
				new BorderLayout(0,0));
			// ---- questionLabel
			{
				questionLabel = new MultiLineLabel(question,MultiLineLabel.CENTER);
				questionPanel.add(questionLabel,"Center");
			}
			add(questionPanel,"Center");
		}

		// ---- buttonPanel
		{
			buttonPanel = new FramedPanel(FramedPanel.DRAW_NOTHING,
				new FlowLayout(FlowLayout.CENTER,20,5));
			// ---- 3 Buttons
			{
				if (answer0!=null) buttonPanel.add(button[0] = new Button(answer0));
					else button[0]=null;
				if (answer1!=null) buttonPanel.add(button[1] = new Button(answer1));
					else button[1]=null;
				if (answer2!=null) buttonPanel.add(button[2] = new Button(answer2));
					else button[2]=null;
				for (int i=0; i<3; i++)
					if (button[i]!=null)
					{
						class ButtonListener implements ActionListener
						{
							int button;
							public ButtonListener (int button)
								{super();this.button = button;}
							public void actionPerformed (ActionEvent e)
								{endDialog(button);}
						}
						button[i].addActionListener(new ButtonListener(i));
					}
			}
			add(buttonPanel,"South");
		}
	}
	public QuestionDialog (Frame parent, String title, boolean modal,
		String question, String[] answers)
	{
		this(parent,title,modal,question,answers[0],answers[1],answers[2]);
	}
	public QuestionDialog (Frame parent, String title, boolean modal,
		String question)
	{
		this(parent,title,modal,question,standardButtonText);
	}
	public QuestionDialog (Frame parent, String title, String question)
	{
		this(parent,title,true,question);
	}
	public QuestionDialog (Frame parent, String question)
	{
		this(parent,"Question",question);
	}

	public int execute ()
	{
		pack();
		Dimension dScreen = getToolkit().getScreenSize();
		Dimension dOwn = getSize();
		setLocation(new Point(
			(dScreen.width-dOwn.width)/2,(dScreen.height-dOwn.height)/2));
		show();
		return answer;
	}

	public static void setStandardButtonText(String[] answers)
	{
		System.arraycopy(answers,0,standardButtonText,0,3);				
	}
	public static void setStandardButtonText(
		String answer0, String answer1, String answer2)
	{
		String[] temp = {answer0,answer1,answer2};
		setStandardButtonText(temp);
	}

	protected void endDialog (int reason) {answer=reason;dispose();}
}

