package luchr.math;

public class ComplexNumber
{
	public static ComplexNumber addiere (ComplexNumber a, ComplexNumber b)
		{return new ComplexNumber(a.Re+b.Re,a.Im+b.Im);}

	public static ComplexNumber subtrahiere (ComplexNumber a, ComplexNumber b)
		{return new ComplexNumber(a.Re-b.Re,a.Im-b.Im);}

	public static ComplexNumber multipliziere (ComplexNumber a, ComplexNumber b)
		{return new ComplexNumber(a.Re*b.Re-a.Im*b.Im,a.Re*b.Im+a.Im*b.Re);}

	public static double getBetrag (ComplexNumber c)
		{return Math.sqrt(c.Re*c.Re+c.Im*c.Im);}

	public static ComplexNumber getKonjugiert (ComplexNumber c)
		{return new ComplexNumber(c.Re,-c.Im);}

	public static ComplexNumber getQuadrat (ComplexNumber c)
		{return new ComplexNumber(c.Re*c.Re-c.Im*c.Im,2*c.Re*c.Im);}

	
	protected double Re,Im;

	public ComplexNumber (double Re, double Im)
		{super();setRe(Re);setIm(Im);}
	public ComplexNumber (double Re) {this(Re,0);}
	public ComplexNumber () {this(0);}

	public String toString ()
		{return "ComplexNumber: "+Re+" + "+Im+"i";}

	public void setRe (double Re) {this.Re=Re;}
	public void setIm (double Im) {this.Im=Im;}

	public double getRe () {return Re;}
	public double getIm () {return Im;}

	public double getBetrag() {return getBetrag(this);}

	public void quadriere ()
	{
		ComplexNumber n=getQuadrat(this);
		Re=n.Re;Im=n.Im;
	}

	public void addiere (ComplexNumber a)
	{
		ComplexNumber n=addiere(this,a);
		Re=n.Re;Im=n.Im;
	}
}
