package luchr.math;

import luchr.lang.Collection;

import java.util.Enumeration;

public class IntervalCollection extends Collection
{
	protected int typeIndex;

	public IntervalCollection (int typeIndex, int capacity, int delta)
	{
		super(capacity,delta);
		this.typeIndex=typeIndex;
	}
	public IntervalCollection (int typeIndex, int capacity)
		{this(typeIndex,capacity,0);}
	public IntervalCollection (int typeIndex) {this(typeIndex,5);}

	/* getTypeIndex */
	public int getTypeIndex () {return typeIndex;}

	/* atInsert */
	public void atInsert (int index, Interval i) throws
		Collection.IndexOutOfRangeException,
		Collection.ObjectAlreadyInCollException,
		IllegalArgumentException
	{
		if (i.getTypeIndex()!=typeIndex) throw
			new IllegalArgumentException("Interval has wrong type!");
		super.atInsert(index,i);
	}

	/* insert */
	public void insert (Interval i) throws
		Collection.ObjectAlreadyInCollException,
		IllegalArgumentException
	{
		if (i.getTypeIndex()!=typeIndex) throw
			new IllegalArgumentException("Interval has wrong type!");
		super.insert(i);
	}

	/* replace */
	public void replace (int index, Interval i) throws
		Collection.IndexOutOfRangeException,
		IllegalArgumentException
	{
		if (i.getTypeIndex()!=typeIndex) throw
			new IllegalArgumentException("Interval has wrong type!");
		super.replace(index,i);
	}
	public void replace (Interval oldi, Interval newi) throws
		Collection.ObjectNotFoundException,
		IllegalArgumentException
	{
		if (newi.getTypeIndex()!=typeIndex) throw
			new IllegalArgumentException("Interval has wrong type!");
		super.replace(oldi,newi);
	}

	/* isNumberInCollection */
	public boolean isNumberInCollection (Number n)
	{
		Enumeration enum = items();
		while (enum.hasMoreElements())
		{
			if (((Interval)(enum.nextElement())).isNumberInInterval(n))
				return true;
		}
		return false;
	}
}
